<?php

namespace Picea\ControlStructure;

class ForeachToken implements ControlStructure {

    public string $token = "foreach";

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) {
        $name = "$".uniqid("foreach_");
        
        $count = count($context->iterationStack ?? []);
        
        if ( $count > 0 ) {
            $name .= "[" . $context->iterationStack[$count - 1]['uid'] . "]";
        }

        $context->iterationStack[] = [
            'or' => false,
            'uid' => $name,
            'token' => 'endforeach',
        ];
        
        return "<?php foreach ($arguments): $name = ( $name ?? 0 ) + 1; ; ?>";
    }
}
